;;---------------------------------------- LICENSE NOTICE ----------------------------------------
;;
;;  This file is part of Angry Kitten: an Amstrad CPC Game made with CPCTelera
;;
;;     Copyright (C) 2019  Irene Clemente Aracil (@irenara), Araceli Lucía Rebollo Domínguez
;;      (@LuciaMew) and Jose Manuel Manresa Guirao (@jmmgMultimedia)
;;
;;
;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;;
;;------------------------------------------------------------------------------------------------


;; Include all CPCtelera constant definitions, macros and variables
.include "cpctelera.h.s"
.include "cpctelera_functions.h.s"
.include "game_manager.h.s"
.include "render_system.h.s"
.include "input_system.h.s"
.module Main
;;
;; Start of _DATA area
;;  SDCC requires at least _DATA and _CODE areas to be declared, but you may use
;;  any one of them for any purpose. Usually, compiler puts _DATA area contents
;;  right after _CODE area contents.
;;
.area _DATA
.area _CODE
.module main
;;
;; MAIN function. This is the entry point of the application.
;;    _main:: global symbol is required for correctly compiling and linking
.globl _song
_main::
   ;; Disable firmware to prevent it from interfering with string drawing
   call  cpct_disableFirmware_asm

   ld    de, #_song
   call  cpct_akp_musicInit_asm

   call  game_man_init                    ;;initialize game manager

   call render_sys_menu
loop:

   call  game_man_getState     ; (1 = enJuego, 2 = Menu, 3 = GameOver, 4 = Controles, 5 = Creditos)
   dec   a
   jr    z, enJuego

   call cpct_akp_stop_asm
   call input_sys_menu
   jr    loop
enJuego:
   call  cpct_waitVSYNC_asm
   call  cpct_akp_musicPlay_asm
   halt
   halt

   call  game_man_getBooleanTiles
   cp    #1
   jr    nz, no_tiles
      call  game_man_drawTiles
      no_tiles:
      call  game_man_changeLevel
      call  game_man_update
      call  cpct_waitVSYNC_asm
      call  game_man_render
   jr    loop
